package simplyconnect.convertor

import groovy.util.logging.Slf4j
import org.apache.tika.sax.BodyContentHandler
import org.apache.tika.parser.html.HtmlParser
import org.apache.tika.metadata.Metadata
import org.xml.sax.ContentHandler

/**
 * User: david
 * Date: 02/02/13
 */

@Slf4j
class HtmlToPlainText implements Convertor {
    String convert(String body) {
        if (body.indexOf('<html') > -1) {
            body = htmlToText(body)
            // replace two or more line endings with a single new line
            // TODO work out what line ending to put
            body = body.replaceAll("[\n\r]{2,}", "\n")
        }
        return body
    }

    private String htmlToText(String body) {
        log.info("Processing html with body length ${body.length()}")
        InputStream input = new ByteArrayInputStream(body.getBytes())
        ContentHandler handler = new BodyContentHandler(-1);
        Metadata metadata = new Metadata();
        new HtmlParser().parse(input, handler, metadata);
        return handler.toString()
    }
}
